searchData={"items":[{"type":"module","title":"Cldr.Calendar.Chinese","doc":"Implementation of the Chinese lunisolar calendar.\n\nIn a ‘regular’ Chinese lunisolar calendar, one year\nis divided into 12 months, with one month corresponding\nto the time between two full moons.\n\nSince the cycle of the moon is not\nan even number of days, a month in the lunar calendar\ncan vary between 29 and 30 days and a normal year can\nhave 353, 354, or 355 days.\n\nThe default epoch for the Chinese lunisolar calendar\nis `~D[-2636-02-15]` which traditional date of the first\nuse of the sexagesimal cycle. It can be changed by setting\nthe `:chinese_epoch` configuration key in `config.exs`:\n\n    # Alternative epoch starting from the reign of Emperor\n    # Huangdi\n    config :ex_cldr_calendars,\n      chinese_epoch: ~D[-2696-01-01]","ref":"Cldr.Calendar.Chinese.html"},{"type":"function","title":"Cldr.Calendar.Chinese.alt_chinese_date_from_iso_days/1","doc":"","ref":"Cldr.Calendar.Chinese.html#alt_chinese_date_from_iso_days/1"},{"type":"function","title":"Cldr.Calendar.Chinese.calendar_base/0","doc":"Identifies that this calendar is month based.","ref":"Cldr.Calendar.Chinese.html#calendar_base/0"},{"type":"function","title":"Cldr.Calendar.Chinese.calendar_year/3","doc":"Returns the calendar year as displayed\non rendered calendars.","ref":"Cldr.Calendar.Chinese.html#calendar_year/3"},{"type":"function","title":"Cldr.Calendar.Chinese.chinese_date_from_iso_days/1","doc":"","ref":"Cldr.Calendar.Chinese.html#chinese_date_from_iso_days/1"},{"type":"function","title":"Cldr.Calendar.Chinese.chinese_date_to_iso_days/1","doc":"","ref":"Cldr.Calendar.Chinese.html#chinese_date_to_iso_days/1"},{"type":"function","title":"Cldr.Calendar.Chinese.cldr_calendar_type/0","doc":"Defines the CLDR calendar type for this calendar.\n\nThis type is used in support of `Cldr.Calendar.\nlocalize/3`.","ref":"Cldr.Calendar.Chinese.html#cldr_calendar_type/0"},{"type":"function","title":"Cldr.Calendar.Chinese.cyclic_year/1","doc":"Returns the year in the lunisolar sexigesimal 60-year\ncycle.\n\nTraditionally years are numbered only within the cycle\nhowever in this implementation the year is an offset from\nthe epoch date. It can be converted to the current year in\nthe current cycle with this function.\n\nThe cycle year is commonly shown on lunisolar calendars and\nit forms part of the traditional Chinese zodiac.\n\n#","ref":"Cldr.Calendar.Chinese.html#cyclic_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Chinese.cyclic_year/1","doc":"* `date` which is any `t:Date.t/0` in the `Cldr.Calendar.Chinese`\n  calendar, *or*\n\n*`year` and `month` representing the calendar year and month.\n\n#","ref":"Cldr.Calendar.Chinese.html#cyclic_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.cyclic_year/1","doc":"* the integer year within the sexigesimal cycle of 60 years.\n\n#","ref":"Cldr.Calendar.Chinese.html#cyclic_year/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Chinese.cyclic_year/1","doc":"iex> Cldr.Calendar.Chinese.cyclic_year(~D[4662-04-01 Cldr.Calendar.Chinese])\n    42\n\n    iex> Cldr.Calendar.Chinese.cyclic_year(~D[4357-01-01 Cldr.Calendar.Chinese])\n    37\n\n    iex> Cldr.Calendar.Chinese.cyclic_year(~D[4321-01-01 Cldr.Calendar.Chinese])\n    1\n\n    iex> Cldr.Calendar.Chinese.cyclic_year(~D[4320-01-01 Cldr.Calendar.Chinese])\n    60","ref":"Cldr.Calendar.Chinese.html#cyclic_year/1-examples"},{"type":"function","title":"Cldr.Calendar.Chinese.cyclic_year/2","doc":"","ref":"Cldr.Calendar.Chinese.html#cyclic_year/2"},{"type":"function","title":"Cldr.Calendar.Chinese.cyclic_year/3","doc":"Returns the cyclic year as displayed\non rendered calendars.","ref":"Cldr.Calendar.Chinese.html#cyclic_year/3"},{"type":"function","title":"Cldr.Calendar.Chinese.day_of_era/3","doc":"Calculates the day and era from the given\n`year`, `month`, and `day`.\n\nBy default we consider on two eras: before the epoch\nand on-or-after the epoch.","ref":"Cldr.Calendar.Chinese.html#day_of_era/3"},{"type":"function","title":"Cldr.Calendar.Chinese.day_of_year/3","doc":"Calculates the day of the year from the given\n`year`, `month`, and `day`.","ref":"Cldr.Calendar.Chinese.html#day_of_year/3"},{"type":"function","title":"Cldr.Calendar.Chinese.days_in_month/1","doc":"Returns how many days there are in the given month.\n\nMust be implemented in derived calendars because\nwe cannot know what the calendar format is.","ref":"Cldr.Calendar.Chinese.html#days_in_month/1"},{"type":"function","title":"Cldr.Calendar.Chinese.days_in_month/2","doc":"Returns how many days there are in the given year\nand month.","ref":"Cldr.Calendar.Chinese.html#days_in_month/2"},{"type":"function","title":"Cldr.Calendar.Chinese.days_in_week/0","doc":"Returns the number days in a a week.","ref":"Cldr.Calendar.Chinese.html#days_in_week/0"},{"type":"function","title":"Cldr.Calendar.Chinese.days_in_year/1","doc":"Returns the number days in a given year.\n\nThe year is the number of years since the\nepoch.","ref":"Cldr.Calendar.Chinese.html#days_in_year/1"},{"type":"function","title":"Cldr.Calendar.Chinese.dragon_festival_for_gregorian_year/1","doc":"Returns the gregorian date of the\ndragon festival (5th day of 5th lunar month)\nfor a given gregorian year.\n\n#","ref":"Cldr.Calendar.Chinese.html#dragon_festival_for_gregorian_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Chinese.dragon_festival_for_gregorian_year/1","doc":"* `year` is any year in the Gregorian calendar.\n\n#","ref":"Cldr.Calendar.Chinese.html#dragon_festival_for_gregorian_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.dragon_festival_for_gregorian_year/1","doc":"* The gregorian date of the dragon festival for\n  the given year.\n\n#","ref":"Cldr.Calendar.Chinese.html#dragon_festival_for_gregorian_year/1-returns"},{"type":"function","title":"Example - Cldr.Calendar.Chinese.dragon_festival_for_gregorian_year/1","doc":"iex> Cldr.Calendar.Chinese.dragon_festival_for_gregorian_year(2021)\n    ~D[2021-06-14]\n\n    iex> Cldr.Calendar.Chinese.dragon_festival_for_gregorian_year(2022)\n    ~D[2022-06-03]\n\n    iex> Cldr.Calendar.Chinese.dragon_festival_for_gregorian_year(2023)\n    ~D[2023-06-22]","ref":"Cldr.Calendar.Chinese.html#dragon_festival_for_gregorian_year/1-example"},{"type":"function","title":"Cldr.Calendar.Chinese.epoch/0","doc":"","ref":"Cldr.Calendar.Chinese.html#epoch/0"},{"type":"function","title":"Cldr.Calendar.Chinese.epoch_day_of_week/0","doc":"","ref":"Cldr.Calendar.Chinese.html#epoch_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.Chinese.extended_year/3","doc":"Returns the extended year as displayed\non rendered calendars.","ref":"Cldr.Calendar.Chinese.html#extended_year/3"},{"type":"function","title":"Cldr.Calendar.Chinese.first_day_of_week/0","doc":"","ref":"Cldr.Calendar.Chinese.html#first_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.Chinese.gregorian_date_for_lunar/3","doc":"Returns the Gregorian date for the given gregorian year\nand lunar month and day.\n\n#","ref":"Cldr.Calendar.Chinese.html#gregorian_date_for_lunar/3"},{"type":"function","title":"Arguments - Cldr.Calendar.Chinese.gregorian_date_for_lunar/3","doc":"* `gregorian_year` is any year in the Gregorian calendar.\n\n* `lunar_month` is either a cardinal month number between 1 and 12 or\n  for a leap month the 2-tuple in the format `{month, :leap}`.\n\n* `day` is any day number valid for `year` and `lunar_month`.\n\n#","ref":"Cldr.Calendar.Chinese.html#gregorian_date_for_lunar/3-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.gregorian_date_for_lunar/3","doc":"* A gregorian date `t:Date.t()`.","ref":"Cldr.Calendar.Chinese.html#gregorian_date_for_lunar/3-returns"},{"type":"function","title":"Cldr.Calendar.Chinese.iso_week_of_year/3","doc":"Calculates the ISO week of the year from the\ngiven `year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.Chinese.html#iso_week_of_year/3"},{"type":"function","title":"Cldr.Calendar.Chinese.last_day_of_week/0","doc":"","ref":"Cldr.Calendar.Chinese.html#last_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.Chinese.leap_month/1","doc":"Returns the ordinal month number of the leap\nmonth for a year, or nil if there is no leap\nmonth.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Chinese.leap_month/1","doc":"* `date_or_year` is either an integer year number\n  or a `t:Date.t/0` in the `Cldr.Calendar.Chinese`\n  calendar.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.leap_month/1","doc":"* either an ordinal month number or\n\n* `nil` indicating there is no leap month in the\n  given year.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Chinese.leap_month/1","doc":"iex> Cldr.Calendar.Chinese.leap_month(4660)\n    3\n\n    iex> Cldr.Calendar.Chinese.leap_month(~D[4660-13-29 Cldr.Calendar.Chinese])\n    3\n\n    iex> Cldr.Calendar.Chinese.leap_month(4661)\n    nil","ref":"Cldr.Calendar.Chinese.html#leap_month/1-examples"},{"type":"function","title":"Cldr.Calendar.Chinese.leap_month?/1","doc":"Returns a boolean indicating if the given year and month\nis a leap month.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month?/1"},{"type":"function","title":"Arguements - Cldr.Calendar.Chinese.leap_month?/1","doc":"* `date` is any `t:Date.t/0` in the `Cldr.Calendar.Chinese` calendar.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month?/1-arguements"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.leap_month?/1","doc":"* A booelan indicating if the given year and month is a leap\n  month.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month?/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Chinese.leap_month?/1","doc":"iex> Cldr.Calendar.Chinese.leap_month?(~D[4660-01-01 Cldr.Calendar.Chinese])\n    false\n\n    iex> Cldr.Calendar.Chinese.leap_month?(~D[4660-03-29 Cldr.Calendar.Chinese])\n    true","ref":"Cldr.Calendar.Chinese.html#leap_month?/1-examples"},{"type":"function","title":"Cldr.Calendar.Chinese.leap_month?/2","doc":"Returns a boolean indicating if the given year and month\nis a leap month.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month?/2"},{"type":"function","title":"Arguements - Cldr.Calendar.Chinese.leap_month?/2","doc":"* `year` is any year in the `Cldr.Calendar.Chinese` calendar.\n\n* `month` is any ordinal month number in the `Cldr.Calendar.Chinese`\n  calendar.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month?/2-arguements"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.leap_month?/2","doc":"* A booelan indicating if the given year and month is a leap\n  month.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_month?/2-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Chinese.leap_month?/2","doc":"iex> Cldr.Calendar.Chinese.leap_month?(4660, 1)\n    false\n\n    iex> Cldr.Calendar.Chinese.leap_month?(4660, 3)\n    true","ref":"Cldr.Calendar.Chinese.html#leap_month?/2-examples"},{"type":"function","title":"Cldr.Calendar.Chinese.leap_year?/1","doc":"Returns a boolean indicating if the given year is a leap\nyear.\n\nLeap years have 13 months. To determine if a year\nis a leap year, calculate the number of new moons\nbetween the 11th month in one year (i.e., the month\ncontaining the Winter Solstice) and the 11th month\nin the following year.\n\nIf there are 13 new moons from the start of the 11th\nmonth in the first year to the start of the 11th\nmonth in the second year, a leap month must be inserted.\n\nIn leap years, at least one month does not contain a\nPrincipal Term. The first such month is the leap month.\n\nThe additional complexity is that a leap year is\ncalculated for the solar year, but the calendar\nis managed in lunar years and months. Therefore when\na leap year is detected, the leap month could be in\nthe current lunar year or the next lunar year.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_year?/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Chinese.leap_year?/1","doc":"* `date_or_year` is either an integer year number\n  or a `t:Date.t/0` in the `Cldr.Calendar.Chinese`\n  calendar.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_year?/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.leap_year?/1","doc":"* A boolaan indicating if the given year is a leap\n  year.\n\n#","ref":"Cldr.Calendar.Chinese.html#leap_year?/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Chinese.leap_year?/1","doc":"iex> Cldr.Calendar.Chinese.leap_year?(4660)\n    true\n\n    iex> Cldr.Calendar.Chinese.leap_year?(4661)\n    false","ref":"Cldr.Calendar.Chinese.html#leap_year?/1-examples"},{"type":"function","title":"Cldr.Calendar.Chinese.lunar_month_of_year/1","doc":"Returns the lunar month of the year for a given date or\nyear and month.\n\nThe lunar month number in the traditional lunisolar calendar is\nbetween 1 and 12 with a leap month added when there are 13 new moons\nbetween Winter solstices. This intercalary leap month is not\nrepresentable in its traditional form in the `t:Date.t/0` struct.\n\nThis function takes a date, or year and month, and returns either the\nmonth number between 1 and 12 or a 2-tuple representing the leap month.\nThis 2-tuple looks like `{month_number, :leap}`.\n\nThe value returned from this function can be passed to `Cldr.Calendar.Chinese.new/3` to\ndefine a date using traditional lunar months.\n\n#","ref":"Cldr.Calendar.Chinese.html#lunar_month_of_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Chinese.lunar_month_of_year/1","doc":"* `date` which is any `t:Date.t/0` in the `Cldr.Calendar.Chinese`\n  calendar, *or*\n\n*`year` and `month` representing the calendar year and month.\n\n#","ref":"Cldr.Calendar.Chinese.html#lunar_month_of_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.lunar_month_of_year/1","doc":"* the lunar month as either an integer between 1 and 12 or a\ntuple of the form `{lunar_month, :leap}`.\n\n#","ref":"Cldr.Calendar.Chinese.html#lunar_month_of_year/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Chinese.lunar_month_of_year/1","doc":"iex> Cldr.Calendar.Chinese.lunar_month_of_year(~D[4660-02-01 Cldr.Calendar.Chinese])\n    2\n\n    iex> Cldr.Calendar.Chinese.lunar_month_of_year(~D[4660-03-01 Cldr.Calendar.Chinese])\n    {2, :leap}\n\n    iex> Cldr.Calendar.Chinese.lunar_month_of_year(~D[4660-04-01 Cldr.Calendar.Chinese])\n    3","ref":"Cldr.Calendar.Chinese.html#lunar_month_of_year/1-examples"},{"type":"function","title":"Cldr.Calendar.Chinese.lunar_month_of_year/2","doc":"","ref":"Cldr.Calendar.Chinese.html#lunar_month_of_year/2"},{"type":"function","title":"Cldr.Calendar.Chinese.month/2","doc":"Returns a `Date.Range.t` representing\na given month of a year.","ref":"Cldr.Calendar.Chinese.html#month/2"},{"type":"function","title":"Cldr.Calendar.Chinese.months_in_leap_year/0","doc":"Returns the number of months in a leap year.","ref":"Cldr.Calendar.Chinese.html#months_in_leap_year/0"},{"type":"function","title":"Cldr.Calendar.Chinese.months_in_ordinary_year/0","doc":"Returns the number of months in a normal year.","ref":"Cldr.Calendar.Chinese.html#months_in_ordinary_year/0"},{"type":"function","title":"Cldr.Calendar.Chinese.months_in_year/1","doc":"Returns the number of months in a\ngiven `year`.","ref":"Cldr.Calendar.Chinese.html#months_in_year/1"},{"type":"function","title":"Cldr.Calendar.Chinese.naive_datetime_from_iso_days/1","doc":"Converts the `t:Calendar.iso_days` format to the\ndatetime format specified by this calendar.","ref":"Cldr.Calendar.Chinese.html#naive_datetime_from_iso_days/1"},{"type":"function","title":"Cldr.Calendar.Chinese.naive_datetime_to_iso_days/7","doc":"Returns the `t:Calendar.iso_days` format of\nthe specified date.","ref":"Cldr.Calendar.Chinese.html#naive_datetime_to_iso_days/7"},{"type":"function","title":"Cldr.Calendar.Chinese.new/3","doc":"Returns a `t:Date.t/0` in the `Elixir.Cldr.Calendar.Chinese` calendar\nformed by a calendar year, a *cardinal* lunar month number\nand a cardinal day number.\n\nThe lunar month number is that used in traditional lunisolar\ncalendar notation. It is either a number between 1 and 12\n(the number of months in an ordinary year) or a leap month\nspecified by the 2-tuple `{month, :leap}`.\n\nThis function is therefore most useful for creating tradition\ncalendar dates for holidays and other events defined in\nthe lunisolar calendar.\n\n#","ref":"Cldr.Calendar.Chinese.html#new/3"},{"type":"function","title":"Arguments - Cldr.Calendar.Chinese.new/3","doc":"* `year` is any year in the `Cldr.Calendar.Chinese` calendar.\n\n* `lunar_month` is either a cardinal month number between 1 and 12 or\n  for a leap month the 2-tuple in the format `{month, :leap}`.\n\n* `day` is any day number valid for `year` and `month`.\n\n#","ref":"Cldr.Calendar.Chinese.html#new/3-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.new/3","doc":"* `{:ok, date}` or\n\n* `{:error, reason}`\n\n#","ref":"Cldr.Calendar.Chinese.html#new/3-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Chinese.new/3","doc":"# Lunar new year\n    iex> Cldr.Calendar.Chinese.new(4660, 1, 1)\n    {:ok, ~D[4660-01-01 Cldr.Calendar.Chinese]}\n\n    # First day of leap month\n    iex> Cldr.Calendar.Chinese.new(4660, {3, :leap}, 1)\n    {:ok, ~D[4660-04-01 Cldr.Calendar.Chinese]}","ref":"Cldr.Calendar.Chinese.html#new/3-examples"},{"type":"function","title":"Cldr.Calendar.Chinese.new!/3","doc":"","ref":"Cldr.Calendar.Chinese.html#new!/3"},{"type":"function","title":"Cldr.Calendar.Chinese.new_year_for_gregorian_year/1","doc":"Returns the gregorian date of the\nLuanr New Year for a given gregorian year.\n\n#","ref":"Cldr.Calendar.Chinese.html#new_year_for_gregorian_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Chinese.new_year_for_gregorian_year/1","doc":"* `gregorian_year` is any year in the Gregorian calendar.\n\n#","ref":"Cldr.Calendar.Chinese.html#new_year_for_gregorian_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Chinese.new_year_for_gregorian_year/1","doc":"* a `t:Date.t/0` representing the Gregorian date of\n  the lunar year of the given Gregorian year.\n\n#","ref":"Cldr.Calendar.Chinese.html#new_year_for_gregorian_year/1-returns"},{"type":"function","title":"Example - Cldr.Calendar.Chinese.new_year_for_gregorian_year/1","doc":"iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2021)\n    ~D[2021-02-12]\n\n    iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2022)\n    ~D[2022-02-01]\n\n    iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2023)\n    ~D[2023-01-22]","ref":"Cldr.Calendar.Chinese.html#new_year_for_gregorian_year/1-example"},{"type":"function","title":"Cldr.Calendar.Chinese.periods_in_year/1","doc":"Returns the number of periods in a given\n`year`. A period corresponds to a month\nin month-based calendars and a week in\nweek-based calendars.","ref":"Cldr.Calendar.Chinese.html#periods_in_year/1"},{"type":"function","title":"Cldr.Calendar.Chinese.plus/6","doc":"Adds an `increment` number of `date_part`s\nto a `year-month-day`.\n\n`date_part` can be `:months` only.","ref":"Cldr.Calendar.Chinese.html#plus/6"},{"type":"function","title":"Cldr.Calendar.Chinese.quarter/2","doc":"Returns a `Date.Range.t` representing\na given quarter of a year.","ref":"Cldr.Calendar.Chinese.html#quarter/2"},{"type":"function","title":"Cldr.Calendar.Chinese.quarter_of_year/3","doc":"Returns the quarter of the year from the given\n`year`, `month`, and `day`.","ref":"Cldr.Calendar.Chinese.html#quarter_of_year/3"},{"type":"function","title":"Cldr.Calendar.Chinese.related_gregorian_year/3","doc":"Returns the related gregorain year as displayed\non rendered calendars.","ref":"Cldr.Calendar.Chinese.html#related_gregorian_year/3"},{"type":"function","title":"Cldr.Calendar.Chinese.valid_date?/3","doc":"Determines if the `date` given is valid according to\nthis calendar.","ref":"Cldr.Calendar.Chinese.html#valid_date?/3"},{"type":"function","title":"Cldr.Calendar.Chinese.week/2","doc":"Returns a `Date.Range.t` representing\na given week of a year.","ref":"Cldr.Calendar.Chinese.html#week/2"},{"type":"function","title":"Cldr.Calendar.Chinese.week_of_month/3","doc":"Calculates the week of the year from the given\n`year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.Chinese.html#week_of_month/3"},{"type":"function","title":"Cldr.Calendar.Chinese.week_of_year/3","doc":"Calculates the week of the year from the given\n`year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.Chinese.html#week_of_year/3"},{"type":"function","title":"Cldr.Calendar.Chinese.weeks_in_year/1","doc":"Returns the number of weeks in a\ngiven `year`.","ref":"Cldr.Calendar.Chinese.html#weeks_in_year/1"},{"type":"function","title":"Cldr.Calendar.Chinese.year/1","doc":"Returns a `Date.Range.t` representing\na given year.","ref":"Cldr.Calendar.Chinese.html#year/1"},{"type":"function","title":"Cldr.Calendar.Chinese.year_of_era/1","doc":"Calculates the year and era from the given `year`.","ref":"Cldr.Calendar.Chinese.html#year_of_era/1"},{"type":"function","title":"Cldr.Calendar.Chinese.year_of_era/3","doc":"Calculates the year and era from the given `date`.","ref":"Cldr.Calendar.Chinese.html#year_of_era/3"},{"type":"module","title":"Cldr.Calendar.Era.Chinese","doc":"Implements a `year_of_era/{1, 2}` function to return\nthe year of era and the era number for the\n`Cldr.Calendar.Era.Chinese` calendar.\n\nThis module is generated at compile time from\nCLDR era data.","ref":"Cldr.Calendar.Era.Chinese.html"},{"type":"function","title":"Cldr.Calendar.Era.Chinese.day_of_era/1","doc":"Returns the day of era and the era number\nfor a given date in `iso_days`.","ref":"Cldr.Calendar.Era.Chinese.html#day_of_era/1"},{"type":"function","title":"Cldr.Calendar.Era.Chinese.year_of_era/1","doc":"Returns the year of era and the era number\nfor a given date in `iso_days`.","ref":"Cldr.Calendar.Era.Chinese.html#year_of_era/1"},{"type":"function","title":"Cldr.Calendar.Era.Chinese.year_of_era/2","doc":"","ref":"Cldr.Calendar.Era.Chinese.html#year_of_era/2"},{"type":"module","title":"Cldr.Calendar.Era.Dangi","doc":"Implements a `year_of_era/{1, 2}` function to return\nthe year of era and the era number for the\n`Cldr.Calendar.Era.Dangi` calendar.\n\nThis module is generated at compile time from\nCLDR era data.","ref":"Cldr.Calendar.Era.Dangi.html"},{"type":"function","title":"Cldr.Calendar.Era.Dangi.day_of_era/1","doc":"Returns the day of era and the era number\nfor a given date in `iso_days`.","ref":"Cldr.Calendar.Era.Dangi.html#day_of_era/1"},{"type":"function","title":"Cldr.Calendar.Era.Dangi.year_of_era/1","doc":"Returns the year of era and the era number\nfor a given date in `iso_days`.","ref":"Cldr.Calendar.Era.Dangi.html#year_of_era/1"},{"type":"function","title":"Cldr.Calendar.Era.Dangi.year_of_era/2","doc":"","ref":"Cldr.Calendar.Era.Dangi.html#year_of_era/2"},{"type":"module","title":"Cldr.Calendar.Korean","doc":"Implementation of the Korean lunisolar calendar.\n\nIn a ‘regular’ Korean lunisolar calendar, one year\nis divided into 12 months, with one month corresponding\nto the time between two full moons.\n\nSince the cycle of the moon is not\nan even number of days, a month in the lunar calendar\ncan vary between 29 and 30 days and a normal year can\nhave 353, 354, or 355 days.\n\nThe default epoch for the Korean lunisolar calendar\nis `~D[-2332-02-15]` which is the traditional year of\nthe founding of the first Korean nation. The epoch can\nbe changed by setting the `:korean_epoch` configuration\nkey in `config.exs`:\n\n    config :ex_cldr_calendars,\n      korean_epoch: ~D[-2332-02-15]","ref":"Cldr.Calendar.Korean.html"},{"type":"function","title":"Cldr.Calendar.Korean.calendar_base/0","doc":"Identifies that this calendar is month based.","ref":"Cldr.Calendar.Korean.html#calendar_base/0"},{"type":"function","title":"Cldr.Calendar.Korean.calendar_year/3","doc":"Returns the calendar year as displayed\non rendered calendars.","ref":"Cldr.Calendar.Korean.html#calendar_year/3"},{"type":"function","title":"Cldr.Calendar.Korean.cldr_calendar_type/0","doc":"Defines the CLDR calendar type for this calendar.\n\nThis type is used in support of `Cldr.Calendar.\nlocalize/3`.","ref":"Cldr.Calendar.Korean.html#cldr_calendar_type/0"},{"type":"function","title":"Cldr.Calendar.Korean.cyclic_year/1","doc":"Returns the year in the lunisolar sexigesimal 60-year\ncycle.\n\nTraditionally years are numbered only within the cycle\nhowever in this implementation the year is an offset from\nthe epoch date. It can be converted to the current year in\nthe current cycle with this function.\n\nThe cycle year is commonly shown on lunisolar calendars and\nit forms part of the traditional Chinese zodiac.\n\n#","ref":"Cldr.Calendar.Korean.html#cyclic_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Korean.cyclic_year/1","doc":"* `date` which is any `t:Date.t/0` in the `Cldr.Calendar.Korean`\n  calendar, *or*\n\n*`year` and `month` representing the calendar year and month.\n\n#","ref":"Cldr.Calendar.Korean.html#cyclic_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.cyclic_year/1","doc":"* the integer year within the sexigesimal cycle of 60 years.\n\n#","ref":"Cldr.Calendar.Korean.html#cyclic_year/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Korean.cyclic_year/1","doc":"iex> Cldr.Calendar.Korean.cyclic_year(~D[4356-04-01 Cldr.Calendar.Korean])\n    36\n\n    iex> Cldr.Calendar.Korean.cyclic_year(~D[4357-01-01 Cldr.Calendar.Korean])\n    37\n\n    iex> Cldr.Calendar.Korean.cyclic_year(~D[4321-01-01 Cldr.Calendar.Korean])\n    1\n\n    iex> Cldr.Calendar.Korean.cyclic_year(~D[4320-01-01 Cldr.Calendar.Korean])\n    60","ref":"Cldr.Calendar.Korean.html#cyclic_year/1-examples"},{"type":"function","title":"Cldr.Calendar.Korean.cyclic_year/2","doc":"","ref":"Cldr.Calendar.Korean.html#cyclic_year/2"},{"type":"function","title":"Cldr.Calendar.Korean.cyclic_year/3","doc":"Returns the cyclic year as displayed\non rendered calendars.","ref":"Cldr.Calendar.Korean.html#cyclic_year/3"},{"type":"function","title":"Cldr.Calendar.Korean.day_of_era/3","doc":"Calculates the day and era from the given\n`year`, `month`, and `day`.\n\nBy default we consider on two eras: before the epoch\nand on-or-after the epoch.","ref":"Cldr.Calendar.Korean.html#day_of_era/3"},{"type":"function","title":"Cldr.Calendar.Korean.day_of_year/3","doc":"Calculates the day of the year from the given\n`year`, `month`, and `day`.","ref":"Cldr.Calendar.Korean.html#day_of_year/3"},{"type":"function","title":"Cldr.Calendar.Korean.days_in_month/1","doc":"Returns how many days there are in the given month.\n\nMust be implemented in derived calendars because\nwe cannot know what the calendar format is.","ref":"Cldr.Calendar.Korean.html#days_in_month/1"},{"type":"function","title":"Cldr.Calendar.Korean.days_in_month/2","doc":"Returns how many days there are in the given year\nand month.","ref":"Cldr.Calendar.Korean.html#days_in_month/2"},{"type":"function","title":"Cldr.Calendar.Korean.days_in_week/0","doc":"Returns the number days in a a week.","ref":"Cldr.Calendar.Korean.html#days_in_week/0"},{"type":"function","title":"Cldr.Calendar.Korean.days_in_year/1","doc":"Returns the number days in a given year.\n\nThe year is the number of years since the\nepoch.","ref":"Cldr.Calendar.Korean.html#days_in_year/1"},{"type":"function","title":"Cldr.Calendar.Korean.epoch/0","doc":"","ref":"Cldr.Calendar.Korean.html#epoch/0"},{"type":"function","title":"Cldr.Calendar.Korean.epoch_day_of_week/0","doc":"","ref":"Cldr.Calendar.Korean.html#epoch_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.Korean.extended_year/3","doc":"Returns the extended year as displayed\non rendered calendars.","ref":"Cldr.Calendar.Korean.html#extended_year/3"},{"type":"function","title":"Cldr.Calendar.Korean.first_day_of_week/0","doc":"","ref":"Cldr.Calendar.Korean.html#first_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.Korean.gregorian_date_for_lunar/3","doc":"Returns the Gregorian date for the given gregorian year\nand lunar month and day.\n\n#","ref":"Cldr.Calendar.Korean.html#gregorian_date_for_lunar/3"},{"type":"function","title":"Arguments - Cldr.Calendar.Korean.gregorian_date_for_lunar/3","doc":"* `gregorian_year` is any year in the Gregorian calendar.\n\n* `lunar_month` is either a cardinal month number between 1 and 12 or\n  for a leap month the 2-tuple in the format `{month, :leap}`.\n\n* `day` is any day number valid for `year` and `lunar_month`.\n\n#","ref":"Cldr.Calendar.Korean.html#gregorian_date_for_lunar/3-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.gregorian_date_for_lunar/3","doc":"* A gregorian date `t:Date.t()`.","ref":"Cldr.Calendar.Korean.html#gregorian_date_for_lunar/3-returns"},{"type":"function","title":"Cldr.Calendar.Korean.iso_week_of_year/3","doc":"Calculates the ISO week of the year from the\ngiven `year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.Korean.html#iso_week_of_year/3"},{"type":"function","title":"Cldr.Calendar.Korean.last_day_of_week/0","doc":"","ref":"Cldr.Calendar.Korean.html#last_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.Korean.leap_month/1","doc":"Returns the ordinal month number of the leap\nmonth for a year, or nil if there is no leap\nmonth.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Korean.leap_month/1","doc":"* `date_or_year` is either an integer year number\n  or a `t:Date.t/0` in the `Cldr.Calendar.Korean`\n  calendar.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.leap_month/1","doc":"* either an ordinal month number or\n\n* `nil` indicating there is no leap month in the\n  given year.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Korean.leap_month/1","doc":"iex> Cldr.Calendar.Korean.leap_month(4356)\n    3\n\n    iex> Cldr.Calendar.Korean.leap_month(~D[4356-13-29 Cldr.Calendar.Korean])\n    3\n\n    iex> Cldr.Calendar.Korean.leap_month(4357)\n    nil","ref":"Cldr.Calendar.Korean.html#leap_month/1-examples"},{"type":"function","title":"Cldr.Calendar.Korean.leap_month?/1","doc":"Returns a boolean indicating if the given year and month\nis a leap month.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month?/1"},{"type":"function","title":"Arguements - Cldr.Calendar.Korean.leap_month?/1","doc":"* `date` is any `t:Date.t/0` in the `Cldr.Calendar.Korean` calendar.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month?/1-arguements"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.leap_month?/1","doc":"* A booelan indicating if the given year and month is a leap\n  month.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month?/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Korean.leap_month?/1","doc":"iex> Cldr.Calendar.Korean.leap_month?(~D[4356-01-01 Cldr.Calendar.Korean])\n    false\n\n    iex> Cldr.Calendar.Korean.leap_month?(~D[4356-03-29 Cldr.Calendar.Korean])\n    true","ref":"Cldr.Calendar.Korean.html#leap_month?/1-examples"},{"type":"function","title":"Cldr.Calendar.Korean.leap_month?/2","doc":"Returns a boolean indicating if the given year and month\nis a leap month.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month?/2"},{"type":"function","title":"Arguements - Cldr.Calendar.Korean.leap_month?/2","doc":"* `year` is any year in the `Cldr.Calendar.Korean` calendar.\n\n* `month` is any ordinal month number in the `Cldr.Calendar.Korean`\n  calendar.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month?/2-arguements"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.leap_month?/2","doc":"* A booelan indicating if the given year and month is a leap\n  month.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_month?/2-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Korean.leap_month?/2","doc":"iex> Cldr.Calendar.Korean.leap_month?(4356, 1)\n    false\n\n    iex> Cldr.Calendar.Korean.leap_month?(4356, 3)\n    true","ref":"Cldr.Calendar.Korean.html#leap_month?/2-examples"},{"type":"function","title":"Cldr.Calendar.Korean.leap_year?/1","doc":"Returns a boolean indicating if the given year is a leap\nyear.\n\nLeap years have 13 months. To determine if a year\nis a leap year, calculate the number of new moons\nbetween the 11th month in one year (i.e., the month\ncontaining the Winter Solstice) and the 11th month\nin the following year.\n\nIf there are 13 new moons from the start of the 11th\nmonth in the first year to the start of the 11th\nmonth in the second year, a leap month must be inserted.\n\nIn leap years, at least one month does not contain a\nPrincipal Term. The first such month is the leap month.\n\nThe additional complexity is that a leap year is\ncalculated for the solar year, but the calendar\nis managed in lunar years and months. Therefore when\na leap year is detected, the leap month could be in\nthe current lunar year or the next lunar year.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_year?/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Korean.leap_year?/1","doc":"* `date_or_year` is either an integer year number\n  or a `t:Date.t/0` in the `Cldr.Calendar.Korean`\n  calendar.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_year?/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.leap_year?/1","doc":"* A booelan indicating if the given year is a leap\n  year.\n\n#","ref":"Cldr.Calendar.Korean.html#leap_year?/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Korean.leap_year?/1","doc":"iex> Cldr.Calendar.Korean.leap_year?(4356)\n    true\n\n    iex> Cldr.Calendar.Korean.leap_year?(4355)\n    false","ref":"Cldr.Calendar.Korean.html#leap_year?/1-examples"},{"type":"function","title":"Cldr.Calendar.Korean.lunar_month_of_year/1","doc":"Returns the lunar month of the year for a given date or\nyear and month.\n\nThe lunar month number in the traditional lunisolar calendar is\nbetween 1 and 12 with a leap month added when there are 13 new moons\nbetween Winter solstices. This intercalary leap month is not\nrepresentable in its traditional form in the `t:Date.t/0` struct.\n\nThis function takes a date, or year and month, and returns either the\nmonth number between 1 and 12 or a 2-tuple representing the leap month.\nThis 2-tuple looks like `{month_number, :leap}`.\n\nThe value returned from this function can be passed to `Cldr.Calendar.Korean.new/3` to\ndefine a date using traditional lunar months.\n\n#","ref":"Cldr.Calendar.Korean.html#lunar_month_of_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Korean.lunar_month_of_year/1","doc":"* `date` which is any `t:Date.t/0` in the `Cldr.Calendar.Korean`\n  calendar, *or*\n\n*`year` and `month` representing the calendar year and month.\n\n#","ref":"Cldr.Calendar.Korean.html#lunar_month_of_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.lunar_month_of_year/1","doc":"* the lunar month as either an integer between 1 and 12 or a\ntuple of the form `{lunar_month, :leap}`.\n\n#","ref":"Cldr.Calendar.Korean.html#lunar_month_of_year/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Korean.lunar_month_of_year/1","doc":"iex> Cldr.Calendar.Korean.lunar_month_of_year(~D[4356-02-01 Cldr.Calendar.Korean])\n    2\n\n    iex> Cldr.Calendar.Korean.lunar_month_of_year(~D[4356-03-01 Cldr.Calendar.Korean])\n    {2, :leap}\n\n    iex> Cldr.Calendar.Korean.lunar_month_of_year(~D[4356-04-01 Cldr.Calendar.Korean])\n    3","ref":"Cldr.Calendar.Korean.html#lunar_month_of_year/1-examples"},{"type":"function","title":"Cldr.Calendar.Korean.lunar_month_of_year/2","doc":"","ref":"Cldr.Calendar.Korean.html#lunar_month_of_year/2"},{"type":"function","title":"Cldr.Calendar.Korean.month/2","doc":"Returns a `Date.Range.t` representing\na given month of a year.","ref":"Cldr.Calendar.Korean.html#month/2"},{"type":"function","title":"Cldr.Calendar.Korean.months_in_leap_year/0","doc":"Returns the number of months in a leap year.","ref":"Cldr.Calendar.Korean.html#months_in_leap_year/0"},{"type":"function","title":"Cldr.Calendar.Korean.months_in_ordinary_year/0","doc":"Returns the number of months in a normal year.","ref":"Cldr.Calendar.Korean.html#months_in_ordinary_year/0"},{"type":"function","title":"Cldr.Calendar.Korean.months_in_year/1","doc":"Returns the number of months in a\ngiven `year`.","ref":"Cldr.Calendar.Korean.html#months_in_year/1"},{"type":"function","title":"Cldr.Calendar.Korean.naive_datetime_from_iso_days/1","doc":"Converts the `t:Calendar.iso_days` format to the\ndatetime format specified by this calendar.","ref":"Cldr.Calendar.Korean.html#naive_datetime_from_iso_days/1"},{"type":"function","title":"Cldr.Calendar.Korean.naive_datetime_to_iso_days/7","doc":"Returns the `t:Calendar.iso_days` format of\nthe specified date.","ref":"Cldr.Calendar.Korean.html#naive_datetime_to_iso_days/7"},{"type":"function","title":"Cldr.Calendar.Korean.new/3","doc":"Returns a `t:Date.t/0` in the `Elixir.Cldr.Calendar.Korean` calendar\nformed by a calendar year, a *cardinal* lunar month number\nand a cardinal day number.\n\nThe lunar month number is that used in traditional lunisolar\ncalendar notation. It is either a number between 1 and 12\n(the number of months in an ordinary year) or a leap month\nspecified by the 2-tuple `{month, :leap}`.\n\nThis function is therefore most useful for creating tradition\ncalendar dates for holidays and other events defined in\nthe lunisolar calendar.\n\n#","ref":"Cldr.Calendar.Korean.html#new/3"},{"type":"function","title":"Arguments - Cldr.Calendar.Korean.new/3","doc":"* `year` is any year in the `Cldr.Calendar.Korean` calendar.\n\n* `lunar_month` is either a cardinal month number between 1 and 12 or\n  for a leap month the 2-tuple in the format `{month, :leap}`.\n\n* `day` is any day number valid for `year` and `month`\n\n#","ref":"Cldr.Calendar.Korean.html#new/3-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.new/3","doc":"* `{:ok, date}` or\n\n* `{:error, reason}`\n\n#","ref":"Cldr.Calendar.Korean.html#new/3-returns"},{"type":"function","title":"Examples - Cldr.Calendar.Korean.new/3","doc":"# Buddha's birthday is the 8th day of\n    # lunar month 4. In a leap year that is the\n    # fifth ordainal month.\n    iex> Cldr.Calendar.Korean.new(4356, 4, 8)\n    {:ok, ~D[4356-05-08 Cldr.Calendar.Korean]}\n\n    # In an ordianry year lunar month four is the same\n    # as the fourth ordinal month.\n    iex(6)> Cldr.Calendar.Korean.new(4355, 4, 8)\n    {:ok, ~D[4355-04-08 Cldr.Calendar.Korean]}","ref":"Cldr.Calendar.Korean.html#new/3-examples"},{"type":"function","title":"Cldr.Calendar.Korean.new!/3","doc":"","ref":"Cldr.Calendar.Korean.html#new!/3"},{"type":"function","title":"Cldr.Calendar.Korean.new_year_for_gregorian_year/1","doc":"Returns the gregorian date of the\nLuanr New Year for a given gregorian year.\n\n#","ref":"Cldr.Calendar.Korean.html#new_year_for_gregorian_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Korean.new_year_for_gregorian_year/1","doc":"* `gregorian_year` is any year in the Gregorian calendar.\n\n#","ref":"Cldr.Calendar.Korean.html#new_year_for_gregorian_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.new_year_for_gregorian_year/1","doc":"* a `t:Date.t/0` representing the Gregorian date of\n  the lunar year of the given Gregorian year.\n\n#","ref":"Cldr.Calendar.Korean.html#new_year_for_gregorian_year/1-returns"},{"type":"function","title":"Example - Cldr.Calendar.Korean.new_year_for_gregorian_year/1","doc":"iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2021)\n    ~D[2021-02-12]\n\n    iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2022)\n    ~D[2022-02-01]\n\n    iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2023)\n    ~D[2023-01-22]","ref":"Cldr.Calendar.Korean.html#new_year_for_gregorian_year/1-example"},{"type":"function","title":"Cldr.Calendar.Korean.periods_in_year/1","doc":"Returns the number of periods in a given\n`year`. A period corresponds to a month\nin month-based calendars and a week in\nweek-based calendars.","ref":"Cldr.Calendar.Korean.html#periods_in_year/1"},{"type":"function","title":"Cldr.Calendar.Korean.plus/6","doc":"Adds an `increment` number of `date_part`s\nto a `year-month-day`.\n\n`date_part` can be `:months` only.","ref":"Cldr.Calendar.Korean.html#plus/6"},{"type":"function","title":"Cldr.Calendar.Korean.quarter/2","doc":"Returns a `Date.Range.t` representing\na given quarter of a year.","ref":"Cldr.Calendar.Korean.html#quarter/2"},{"type":"function","title":"Cldr.Calendar.Korean.quarter_of_year/3","doc":"Returns the quarter of the year from the given\n`year`, `month`, and `day`.","ref":"Cldr.Calendar.Korean.html#quarter_of_year/3"},{"type":"function","title":"Cldr.Calendar.Korean.related_gregorian_year/3","doc":"Returns the related gregorain year as displayed\non rendered calendars.","ref":"Cldr.Calendar.Korean.html#related_gregorian_year/3"},{"type":"function","title":"Cldr.Calendar.Korean.thanksgiving_for_gregorian_year/1","doc":"Returns the Gregorian date of Korean thanksgiving\n(15th day of 8th lunar month) for a given Gregorian year.\n\n#","ref":"Cldr.Calendar.Korean.html#thanksgiving_for_gregorian_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.Korean.thanksgiving_for_gregorian_year/1","doc":"* `year` is any year in the Gregorian calendar.\n\n#","ref":"Cldr.Calendar.Korean.html#thanksgiving_for_gregorian_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Korean.thanksgiving_for_gregorian_year/1","doc":"* The Gregorian date of the Korean thanksgiving date for\n  the given year.\n\n#","ref":"Cldr.Calendar.Korean.html#thanksgiving_for_gregorian_year/1-returns"},{"type":"function","title":"Example - Cldr.Calendar.Korean.thanksgiving_for_gregorian_year/1","doc":"iex> Cldr.Calendar.Korean.thanksgiving_for_gregorian_year(2021)\n    ~D[2021-09-21]\n\n    iex> Cldr.Calendar.Korean.thanksgiving_for_gregorian_year(2022)\n    ~D[2022-09-10]\n\n    iex> Cldr.Calendar.Korean.thanksgiving_for_gregorian_year(2023)\n    ~D[2023-09-29]","ref":"Cldr.Calendar.Korean.html#thanksgiving_for_gregorian_year/1-example"},{"type":"function","title":"Cldr.Calendar.Korean.valid_date?/3","doc":"Determines if the `date` given is valid according to\nthis calendar.","ref":"Cldr.Calendar.Korean.html#valid_date?/3"},{"type":"function","title":"Cldr.Calendar.Korean.week/2","doc":"Returns a `Date.Range.t` representing\na given week of a year.","ref":"Cldr.Calendar.Korean.html#week/2"},{"type":"function","title":"Cldr.Calendar.Korean.week_of_month/3","doc":"Calculates the week of the year from the given\n`year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.Korean.html#week_of_month/3"},{"type":"function","title":"Cldr.Calendar.Korean.week_of_year/3","doc":"Calculates the week of the year from the given\n`year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.Korean.html#week_of_year/3"},{"type":"function","title":"Cldr.Calendar.Korean.weeks_in_year/1","doc":"Returns the number of weeks in a\ngiven `year`.","ref":"Cldr.Calendar.Korean.html#weeks_in_year/1"},{"type":"function","title":"Cldr.Calendar.Korean.year/1","doc":"Returns a `Date.Range.t` representing\na given year.","ref":"Cldr.Calendar.Korean.html#year/1"},{"type":"function","title":"Cldr.Calendar.Korean.year_of_era/1","doc":"Calculates the year and era from the given `year`.","ref":"Cldr.Calendar.Korean.html#year_of_era/1"},{"type":"function","title":"Cldr.Calendar.Korean.year_of_era/3","doc":"Calculates the year and era from the given `date`.","ref":"Cldr.Calendar.Korean.html#year_of_era/3"},{"type":"module","title":"Cldr.Calendar.LunarJapanese","doc":"Implementation of the Japanese lunisolar calendar.\n\nIn a normal Japanese lunisolar calendar, one year\nis divided into 12 months, with one month corresponding\nto the time between two full moons.\n\nSince the cycle of the moon is not\nan even number of days, a month in the lunar calendar\ncan vary between 29 and 30 days and a normal year can\nhave 353, 354, or 355 days.\n\nWe define the epoch to the first new moon in the first\nyear of the [Taika era](https://en.wikipedia.org/wiki/Taika_(era))\nwhich is recorded as the first imperial era.\n\nThe epoch can be changed by setting the `:lunar_japanese_epoch`\nconfiguration key in `config.exs`:\n\n    # Alternative epoch starting from the reign of Emperor\n    # Huangdi\n    config :ex_cldr_calendars,\n      lunar_japanese_epoch: ~D[0645-07-20]","ref":"Cldr.Calendar.LunarJapanese.html"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.calendar_base/0","doc":"Identifies that this calendar is month based.","ref":"Cldr.Calendar.LunarJapanese.html#calendar_base/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.calendar_year/3","doc":"Returns the calendar year as displayed\non rendered calendars.","ref":"Cldr.Calendar.LunarJapanese.html#calendar_year/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.cldr_calendar_type/0","doc":"Defines the CLDR calendar type for this calendar.\n\nThis type is used in support of `Cldr.Calendar.\nlocalize/3`.","ref":"Cldr.Calendar.LunarJapanese.html#cldr_calendar_type/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.cyclic_year/1","doc":"Returns the year in the lunisolar sexigesimal 60-year\ncycle.\n\nTraditionally years are numbered only within the cycle\nhowever in this implementation the year is an offset from\nthe epoch date. It can be converted to the current year in\nthe current cycle with this function.\n\nThe cycle year is commonly shown on lunisolar calendars and\nit forms part of the traditional Chinese zodiac.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#cyclic_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.LunarJapanese.cyclic_year/1","doc":"* `date` which is any `t:Date.t/0` in the `Cldr.Calendar.LunarJapanese`\n  calendar, *or*\n\n*`year` and `month` representing the calendar year and month.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#cyclic_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.cyclic_year/1","doc":"* the integer year within the sexigesimal cycle of 60 years.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#cyclic_year/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.LunarJapanese.cyclic_year/1","doc":"iex> Cldr.Calendar.LunarJapanese.cyclic_year(~D[1380-04-01 Cldr.Calendar.LunarJapanese])\n    60\n\n    iex> Cldr.Calendar.LunarJapanese.cyclic_year(~D[1381-01-01 Cldr.Calendar.LunarJapanese])\n    1\n\n    iex> Cldr.Calendar.LunarJapanese.cyclic_year(~D[1200-01-02 Cldr.Calendar.LunarJapanese])\n    60\n\n    iex> Cldr.Calendar.LunarJapanese.cyclic_year(~D[1260-01-01 Cldr.Calendar.LunarJapanese])\n    60","ref":"Cldr.Calendar.LunarJapanese.html#cyclic_year/1-examples"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.cyclic_year/2","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#cyclic_year/2"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.cyclic_year/3","doc":"Returns the cyclic year as displayed\non rendered calendars.","ref":"Cldr.Calendar.LunarJapanese.html#cyclic_year/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.date_to_iso_days/3","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#date_to_iso_days/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.day_of_era/3","doc":"Calculates the day and era from the given\n`year`, `month`, and `day`.\n\nBy default we consider on two eras: before the epoch\nand on-or-after the epoch.","ref":"Cldr.Calendar.LunarJapanese.html#day_of_era/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.day_of_year/3","doc":"Calculates the day of the year from the given\n`year`, `month`, and `day`.","ref":"Cldr.Calendar.LunarJapanese.html#day_of_year/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.days_in_month/1","doc":"Returns how many days there are in the given month.\n\nMust be implemented in derived calendars because\nwe cannot know what the calendar format is.","ref":"Cldr.Calendar.LunarJapanese.html#days_in_month/1"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.days_in_month/2","doc":"Returns how many days there are in the given year\nand month.","ref":"Cldr.Calendar.LunarJapanese.html#days_in_month/2"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.days_in_week/0","doc":"Returns the number days in a a week.","ref":"Cldr.Calendar.LunarJapanese.html#days_in_week/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.days_in_year/1","doc":"Returns the number days in a given year.\n\nThe year is the number of years since the\nepoch.","ref":"Cldr.Calendar.LunarJapanese.html#days_in_year/1"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.elapsed_years/2","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#elapsed_years/2"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.epoch/0","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#epoch/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.epoch_day_of_week/0","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#epoch_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.extended_year/3","doc":"Returns the extended year as displayed\non rendered calendars.","ref":"Cldr.Calendar.LunarJapanese.html#extended_year/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.first_day_of_week/0","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#first_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.gregorian_date_for_lunar/3","doc":"Returns the Gregorian date for the given gregorian year\nand lunar month and day.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#gregorian_date_for_lunar/3"},{"type":"function","title":"Arguments - Cldr.Calendar.LunarJapanese.gregorian_date_for_lunar/3","doc":"* `gregorian_year` is any year in the Gregorian calendar.\n\n* `lunar_month` is either a cardinal month number between 1 and 12 or\n  for a leap month the 2-tuple in the format `{month, :leap}`.\n\n* `day` is any day number valid for `year` and `lunar_month`.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#gregorian_date_for_lunar/3-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.gregorian_date_for_lunar/3","doc":"* A gregorian date `t:Date.t()`.","ref":"Cldr.Calendar.LunarJapanese.html#gregorian_date_for_lunar/3-returns"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.iso_week_of_year/3","doc":"Calculates the ISO week of the year from the\ngiven `year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.LunarJapanese.html#iso_week_of_year/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.last_day_of_week/0","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#last_day_of_week/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.leap_month/1","doc":"Returns the ordinal month number of the leap\nmonth for a year, or nil if there is no leap\nmonth.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month/1"},{"type":"function","title":"Arguments - Cldr.Calendar.LunarJapanese.leap_month/1","doc":"* `date_or_year` is either an integer year number\n  or a `t:Date.t/0` in the `Cldr.Calendar.LunarJapanese`\n  calendar.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.leap_month/1","doc":"* either an ordinal month number or\n\n* `nil` indicating there is no leap month in the\n  given year.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.LunarJapanese.leap_month/1","doc":"iex> Cldr.Calendar.LunarJapanese.leap_month(1379)\n    3\n\n    iex> Cldr.Calendar.LunarJapanese.leap_month(~D[1379-13-29 Cldr.Calendar.LunarJapanese])\n    3\n\n    iex> Cldr.Calendar.LunarJapanese.leap_month(1380)\n    nil","ref":"Cldr.Calendar.LunarJapanese.html#leap_month/1-examples"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.leap_month?/1","doc":"Returns a boolean indicating if the given year and month\nis a leap month.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month?/1"},{"type":"function","title":"Arguements - Cldr.Calendar.LunarJapanese.leap_month?/1","doc":"* `date` is any `t:Date.t/0` in the `Cldr.Calendar.LunarJapanese` calendar.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month?/1-arguements"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.leap_month?/1","doc":"* A booelan indicating if the given year and month is a leap\n  month.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month?/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.LunarJapanese.leap_month?/1","doc":"iex> Cldr.Calendar.LunarJapanese.leap_month?(~D[1379-01-01 Cldr.Calendar.LunarJapanese])\n    false\n\n    iex> Cldr.Calendar.LunarJapanese.leap_month?(~D[1379-03-29 Cldr.Calendar.LunarJapanese])\n    true","ref":"Cldr.Calendar.LunarJapanese.html#leap_month?/1-examples"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.leap_month?/2","doc":"Returns a boolean indicating if the given year and month\nis a leap month.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month?/2"},{"type":"function","title":"Arguements - Cldr.Calendar.LunarJapanese.leap_month?/2","doc":"* `year` is any year in the `Cldr.Calendar.LunarJapanese` calendar.\n\n* `month` is any ordinal month number in the `Cldr.Calendar.LunarJapanese`\n  calendar.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month?/2-arguements"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.leap_month?/2","doc":"* A booelan indicating if the given year and month is a leap\n  month.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_month?/2-returns"},{"type":"function","title":"Examples - Cldr.Calendar.LunarJapanese.leap_month?/2","doc":"iex> Cldr.Calendar.LunarJapanese.leap_month?(1379, 1)\n    false\n\n    iex> Cldr.Calendar.LunarJapanese.leap_month?(1379, 3)\n    true","ref":"Cldr.Calendar.LunarJapanese.html#leap_month?/2-examples"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.leap_year?/1","doc":"Returns a boolean indicating if the given year is a leap\nyear.\n\nLeap years have 13 months. To determine if a year\nis a leap year, calculate the number of new moons\nbetween the 11th month in one year (i.e., the month\ncontaining the Winter Solstice) and the 11th month\nin the following year.\n\nIf there are 13 new moons from the start of the 11th\nmonth in the first year to the start of the 11th\nmonth in the second year, a leap month must be inserted.\n\nIn leap years, at least one month does not contain a\nPrincipal Term. The first such month is the leap month.\n\nThe additional complexity is that a leap year is\ncalculated for the solar year, but the calendar\nis managed in lunar years and months. Therefore when\na leap year is detected, the leap month could be in\nthe current lunar year or the next lunar year.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_year?/1"},{"type":"function","title":"Arguments - Cldr.Calendar.LunarJapanese.leap_year?/1","doc":"* `date_or_year` is either an integer year number\n  or a `t:Date.t/0` in the `Cldr.Calendar.LunarJapanese`\n  calendar.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_year?/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.leap_year?/1","doc":"* A booelan indicating if the given year is a leap\n  year.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#leap_year?/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.LunarJapanese.leap_year?/1","doc":"iex> Cldr.Calendar.LunarJapanese.leap_year?(1379)\n    true\n\n    iex> Cldr.Calendar.LunarJapanese.leap_year?(1378)\n    false","ref":"Cldr.Calendar.LunarJapanese.html#leap_year?/1-examples"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.lunar_month_of_year/1","doc":"Returns the lunar month of the year for a given date or\nyear and month.\n\nThe lunar month number in the traditional lunisolar calendar is\nbetween 1 and 12 with a leap month added when there are 13 new moons\nbetween Winter solstices. This intercalary leap month is not\nrepresentable in its traditional form in the `t:Date.t/0` struct.\n\nThis function takes a date, or year and month, and returns either the\nmonth number between 1 and 12 or a 2-tuple representing the leap month.\nThis 2-tuple looks like `{month_number, :leap}`.\n\nThe value returned from this function can be passed to `Cldr.Calendar.LunarJapanese.new/3` to\ndefine a date using traditional lunar months.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#lunar_month_of_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.LunarJapanese.lunar_month_of_year/1","doc":"* `date` which is any `t:Date.t/0` in the `Cldr.Calendar.LunarJapanese`\n  calendar, *or*\n\n*`year` and `month` representing the calendar year and month.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#lunar_month_of_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.lunar_month_of_year/1","doc":"* the lunar month as either an integer between 1 and 12 or a\ntuple of the form `{lunar_month, :leap}`.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#lunar_month_of_year/1-returns"},{"type":"function","title":"Examples - Cldr.Calendar.LunarJapanese.lunar_month_of_year/1","doc":"iex> Cldr.Calendar.LunarJapanese.lunar_month_of_year(~D[1379-02-01 Cldr.Calendar.LunarJapanese])\n    2\n\n    iex> Cldr.Calendar.LunarJapanese.lunar_month_of_year(~D[1379-03-01 Cldr.Calendar.LunarJapanese])\n    {2, :leap}\n\n    iex> Cldr.Calendar.LunarJapanese.lunar_month_of_year(~D[1379-04-01 Cldr.Calendar.LunarJapanese])\n    3","ref":"Cldr.Calendar.LunarJapanese.html#lunar_month_of_year/1-examples"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.lunar_month_of_year/2","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#lunar_month_of_year/2"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.month/2","doc":"Returns a `Date.Range.t` representing\na given month of a year.","ref":"Cldr.Calendar.LunarJapanese.html#month/2"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.months_in_leap_year/0","doc":"Returns the number of months in a leap year.","ref":"Cldr.Calendar.LunarJapanese.html#months_in_leap_year/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.months_in_ordinary_year/0","doc":"Returns the number of months in a normal year.","ref":"Cldr.Calendar.LunarJapanese.html#months_in_ordinary_year/0"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.months_in_year/1","doc":"Returns the number of months in a\ngiven `year`.","ref":"Cldr.Calendar.LunarJapanese.html#months_in_year/1"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.naive_datetime_from_iso_days/1","doc":"Converts the `t:Calendar.iso_days` format to the\ndatetime format specified by this calendar.","ref":"Cldr.Calendar.LunarJapanese.html#naive_datetime_from_iso_days/1"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.naive_datetime_to_iso_days/7","doc":"Returns the `t:Calendar.iso_days` format of\nthe specified date.","ref":"Cldr.Calendar.LunarJapanese.html#naive_datetime_to_iso_days/7"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.new/3","doc":"Returns a `t:Date.t/0` in the `Elixir.Cldr.Calendar.LunarJapanese` calendar\nformed by a calendar year, a *cardinal* lunar month number\nand a cardinal day number.\n\nThe lunar month number is that used in traditional lunisolar\ncalendar notation. It is either a number between 1 and 12\n(the number of months in an ordinary year) or a leap month\nspecified by the 2-tuple `{month, :leap}`.\n\nThis function is therefore most useful for creating tradition\ncalendar dates for holidays and other events defined in\nthe lunisolar calendar.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#new/3"},{"type":"function","title":"Arguments - Cldr.Calendar.LunarJapanese.new/3","doc":"* `year` is any year in the `Cldr.Calendar.LunarJapanese` calendar.\n\n* `lunar_month` is either a cardinal month number between 1 and 12 or\n  for a leap month the 2-tuple in the format `{month, :leap}`.\n\n* `day` is any day number valid for `year` and `month`\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#new/3-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.new/3","doc":"* `{:ok, date}` or\n\n* `{:error, reason}`\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#new/3-returns"},{"type":"function","title":"Examples - Cldr.Calendar.LunarJapanese.new/3","doc":"# Lunar new year\n    iex> Cldr.Calendar.LunarJapanese.new(1379, 1, 1)\n    {:ok, ~D[1379-01-01 Cldr.Calendar.LunarJapanese]}\n\n    # First day of leap month\n    iex> Cldr.Calendar.LunarJapanese.new(1379, {3, :leap}, 1)\n    {:ok, ~D[1379-04-01 Cldr.Calendar.LunarJapanese]}","ref":"Cldr.Calendar.LunarJapanese.html#new/3-examples"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.new!/3","doc":"","ref":"Cldr.Calendar.LunarJapanese.html#new!/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.new_year_for_gregorian_year/1","doc":"Returns the gregorian date of the\nLuanr New Year for a given gregorian year.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#new_year_for_gregorian_year/1"},{"type":"function","title":"Arguments - Cldr.Calendar.LunarJapanese.new_year_for_gregorian_year/1","doc":"* `gregorian_year` is any year in the Gregorian calendar.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#new_year_for_gregorian_year/1-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.LunarJapanese.new_year_for_gregorian_year/1","doc":"* a `t:Date.t/0` representing the Gregorian date of\n  the lunar year of the given Gregorian year.\n\n#","ref":"Cldr.Calendar.LunarJapanese.html#new_year_for_gregorian_year/1-returns"},{"type":"function","title":"Example - Cldr.Calendar.LunarJapanese.new_year_for_gregorian_year/1","doc":"iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2021)\n    ~D[2021-02-12]\n\n    iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2022)\n    ~D[2022-02-01]\n\n    iex> Cldr.Calendar.Chinese.new_year_for_gregorian_year(2023)\n    ~D[2023-01-22]","ref":"Cldr.Calendar.LunarJapanese.html#new_year_for_gregorian_year/1-example"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.periods_in_year/1","doc":"Returns the number of periods in a given\n`year`. A period corresponds to a month\nin month-based calendars and a week in\nweek-based calendars.","ref":"Cldr.Calendar.LunarJapanese.html#periods_in_year/1"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.plus/6","doc":"Adds an `increment` number of `date_part`s\nto a `year-month-day`.\n\n`date_part` can be `:months` only.","ref":"Cldr.Calendar.LunarJapanese.html#plus/6"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.quarter/2","doc":"Returns a `Date.Range.t` representing\na given quarter of a year.","ref":"Cldr.Calendar.LunarJapanese.html#quarter/2"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.quarter_of_year/3","doc":"Returns the quarter of the year from the given\n`year`, `month`, and `day`.","ref":"Cldr.Calendar.LunarJapanese.html#quarter_of_year/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.related_gregorian_year/3","doc":"Returns the related gregorain year as displayed\non rendered calendars.","ref":"Cldr.Calendar.LunarJapanese.html#related_gregorian_year/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.valid_date?/3","doc":"Determines if the `date` given is valid according to\nthis calendar.","ref":"Cldr.Calendar.LunarJapanese.html#valid_date?/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.week/2","doc":"Returns a `Date.Range.t` representing\na given week of a year.","ref":"Cldr.Calendar.LunarJapanese.html#week/2"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.week_of_month/3","doc":"Calculates the week of the year from the given\n`year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.LunarJapanese.html#week_of_month/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.week_of_year/3","doc":"Calculates the week of the year from the given\n`year`, `month`, and `day`.\n\nBy default this function always returns\n`{:error, :not_defined}`.","ref":"Cldr.Calendar.LunarJapanese.html#week_of_year/3"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.weeks_in_year/1","doc":"Returns the number of weeks in a\ngiven `year`.","ref":"Cldr.Calendar.LunarJapanese.html#weeks_in_year/1"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.year/1","doc":"Returns a `Date.Range.t` representing\na given year.","ref":"Cldr.Calendar.LunarJapanese.html#year/1"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.year_of_era/1","doc":"Calculates the year and era from the given `year`.","ref":"Cldr.Calendar.LunarJapanese.html#year_of_era/1"},{"type":"function","title":"Cldr.Calendar.LunarJapanese.year_of_era/3","doc":"Calculates the year and era from the given `date`.","ref":"Cldr.Calendar.LunarJapanese.html#year_of_era/3"},{"type":"module","title":"Cldr.Calendar.Lunisolar","doc":"Template for building lunisolar calendars.  See\n`Cldr.Calendar.Chinese` for an example implementation.\n\nThe functions in this module should only be called\nfrom lunisolar implementations.\n\nSome conventions are used for naming in this module:\n\n* `year` refers to the calendar year with is the number\n  of years since the epoch.\n\n* `cyclical_year` is the year in the sexigesimal cycle.\n\n* `month` is the ordinal month in the calendar year that\n  is between 1 and 12 for an ordinary year and between 1\n  and 13 in a leap year.\n\n* `lunar_month` is a the month numbered similarly to how months\n  are traditionally numbered. The month will be a cardinal\n  number between 1 and 12 in all years with the addition of\n  a leap month in leap years. The leap month is represented\n  by `{month, :keap}`.","ref":"Cldr.Calendar.Lunisolar.html"},{"type":"function","title":"Cldr.Calendar.Lunisolar.chinese_new_year_for_gregorian_year/2","doc":"Return iso_days of Lunar New Year at `location` for a\nGregorian year.","ref":"Cldr.Calendar.Lunisolar.html#chinese_new_year_for_gregorian_year/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.current_major_solar_term/2","doc":"Return last Chinese major solar term (zhongqi) before\n`iso_days`.","ref":"Cldr.Calendar.Lunisolar.html#current_major_solar_term/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.current_minor_solar_term/2","doc":"Return last minor solar term (jieqi) before `iso_days`.","ref":"Cldr.Calendar.Lunisolar.html#current_minor_solar_term/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.cyclical_date_to_iso_days/6","doc":"","ref":"Cldr.Calendar.Lunisolar.html#cyclical_date_to_iso_days/6"},{"type":"function","title":"Cldr.Calendar.Lunisolar.date_from_iso_days/3","doc":"","ref":"Cldr.Calendar.Lunisolar.html#date_from_iso_days/3"},{"type":"function","title":"Cldr.Calendar.Lunisolar.date_to_iso_days/5","doc":"","ref":"Cldr.Calendar.Lunisolar.html#date_to_iso_days/5"},{"type":"function","title":"Cldr.Calendar.Lunisolar.day_name/1","doc":"Return sexagesimal name for date, date.","ref":"Cldr.Calendar.Lunisolar.html#day_name/1"},{"type":"function","title":"Cldr.Calendar.Lunisolar.day_name_on_or_before/2","doc":"Return iso_days of latest date on or before iso_days, that\nhas Chinese name, name.","ref":"Cldr.Calendar.Lunisolar.html#day_name_on_or_before/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.december_solstice_on_or_before/2","doc":"Return iso_days, in the `location` zone, of winter solstice\non or before `iso_days`.","ref":"Cldr.Calendar.Lunisolar.html#december_solstice_on_or_before/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.elapsed_years/1","doc":"","ref":"Cldr.Calendar.Lunisolar.html#elapsed_years/1"},{"type":"function","title":"Cldr.Calendar.Lunisolar.gregorian_date_for_lunar/5","doc":"Returns the Gregorian date for the lunar month and day in a\ngiven Gregorian year.","ref":"Cldr.Calendar.Lunisolar.html#gregorian_date_for_lunar/5"},{"type":"function","title":"Cldr.Calendar.Lunisolar.is_prior_leap_month?/3","doc":"Return `true` if there is a Lunar leap month on or after lunar\nmonth starting on `m_prime` and at or before\nlunar month starting at `m`.","ref":"Cldr.Calendar.Lunisolar.html#is_prior_leap_month?/3"},{"type":"function","title":"Cldr.Calendar.Lunisolar.leap_month/3","doc":"Returns the leap month number for a given year\nor nil if its not a leap year.","ref":"Cldr.Calendar.Lunisolar.html#leap_month/3"},{"type":"function","title":"Cldr.Calendar.Lunisolar.leap_month?/4","doc":"Approximately every three years (7 times in 19 years),\na leap month is added to the Chinese calendar.\n\nTo determine when, find the number of new moons between\nthe 11th month in one year and the 11th month in the\nfollowing year.\n\nA leap month is inserted if there are 13 New Moons\nfrom the start of the 11th month in the first year\nto the start of the 11th month in the next year.\n\nThe Chinese calendar uses a solar term system\nthat has 12 principal terms to indicate when the Sun's\nlongitude is a multiple of 30 degrees.\n\nUnlike all other months, the leap month does not\ncontain a principal term (Zhongqi).","ref":"Cldr.Calendar.Lunisolar.html#leap_month?/4"},{"type":"function","title":"Cldr.Calendar.Lunisolar.leap_month?/5","doc":"","ref":"Cldr.Calendar.Lunisolar.html#leap_month?/5"},{"type":"function","title":"Cldr.Calendar.Lunisolar.leap_year?/3","doc":"Returns if the given year is a leap\nyear.\n\nLeap years have 13 months. To determine if a year\nis a leap year, calculate the number of new moons\nbetween the 11th month in one year (i.e., the month\ncontaining the Winter Solstice) and the 11th month\nin the following year.\n\nIf there are 13 new moons from the start of the 11th\nmonth in the first year to the start of the 11th\nmonth in the second year, a leap month must be inserted.\n\nIn leap years, at least one month does not contain a\nPrincipal Term. The first such month is the leap month.\n\nThe additional complexity is that a leap year is\ncalculated for the solar year, but the calendar\nis managed in lunar years and months. Therefore when\na leap year is detected, the leap month could be in\nthe current lunar year or the next lunar year.","ref":"Cldr.Calendar.Lunisolar.html#leap_year?/3"},{"type":"function","title":"Cldr.Calendar.Lunisolar.location/2","doc":"","ref":"Cldr.Calendar.Lunisolar.html#location/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.major_solar_term_on_or_after/2","doc":"Return moment at `location` of the first major\nsolar term (zhongqi) on or after `iso_days`.  The\nmajor terms begin when the sun's longitude is a\nmultiple of 30 degrees.","ref":"Cldr.Calendar.Lunisolar.html#major_solar_term_on_or_after/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.midnight_in_location/2","doc":"Return Universal time of (clock) midnight at start of `iso_days`,\nat `location`.","ref":"Cldr.Calendar.Lunisolar.html#midnight_in_location/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.minor_solar_term_on_or_after/2","doc":"Return moment at `location` of the first minor solar\nterm (jieqi) on or after `iso_days`.  The minor terms\nbegin when the sun's longitude is an odd multiple of 15 degrees.","ref":"Cldr.Calendar.Lunisolar.html#minor_solar_term_on_or_after/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.month_name/2","doc":"Return sexagesimal name for month, month, of Chinese year, year.","ref":"Cldr.Calendar.Lunisolar.html#month_name/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.name_difference/2","doc":"Return the number of names from Lunar name c_name1 to the\nnext occurrence of Lunar name c_name2.","ref":"Cldr.Calendar.Lunisolar.html#name_difference/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.new/5","doc":"Create a new date in the lunisolar calendar.\n\n#","ref":"Cldr.Calendar.Lunisolar.html#new/5"},{"type":"function","title":"Arguments - Cldr.Calendar.Lunisolar.new/5","doc":"* `year` is a year in the lunisolar calendar.\n\n* `month` is a month in the lunisolar calendar\nas either a positive integer or a tuple of the\nform `{month, :leap}` representing the leap month.\n\n* `day` is a day of month.\n\n* `epoch` is the epoch in iso days for the lunisolar\n  calendar.\n\n* `location_fun` is a 1-arity function that returns\n  the tuple of the form `{latitude, longitude, altitude, hour_offset}`\n  for  the lunisolar calendar.\n\n#","ref":"Cldr.Calendar.Lunisolar.html#new/5-arguments"},{"type":"function","title":"Returns - Cldr.Calendar.Lunisolar.new/5","doc":"* `iso_days` begin the iso_days for the given date in\n  based upon the given location.","ref":"Cldr.Calendar.Lunisolar.html#new/5-returns"},{"type":"function","title":"Cldr.Calendar.Lunisolar.new_moon_before/2","doc":"Return `iso_day` at `location` of first new moon\nbefore `iso_days`.","ref":"Cldr.Calendar.Lunisolar.html#new_moon_before/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.new_moon_on_or_after/2","doc":"Return `iso_day` at `location` of first new moon on or after\n`iso_days`.","ref":"Cldr.Calendar.Lunisolar.html#new_moon_on_or_after/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.new_year_in_sui/2","doc":"Return `iso_day` of Lunar New Year in sui\n(period from solstice to solstice)\ncontaining `iso_days`.","ref":"Cldr.Calendar.Lunisolar.html#new_year_in_sui/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.new_year_on_or_before/2","doc":"Return `iso_day` of Lunar New Year on or\nbefore `iso_days` at `location`.","ref":"Cldr.Calendar.Lunisolar.html#new_year_on_or_before/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.no_major_solar_term?/2","doc":"Return `true` if lunar month starting on `iso_days`\nat `location` has no major solar term.","ref":"Cldr.Calendar.Lunisolar.html#no_major_solar_term?/2"},{"type":"function","title":"Cldr.Calendar.Lunisolar.solar_longitude_on_or_after/3","doc":"Return moment at `location` of the first date on or after\n`iso_days` when the solar longitude\nwill be 'lambda' degrees.","ref":"Cldr.Calendar.Lunisolar.html#solar_longitude_on_or_after/3"},{"type":"function","title":"Cldr.Calendar.Lunisolar.stem_and_branch/1","doc":"Return the name of the Lunar\nsexagesimal cycle.","ref":"Cldr.Calendar.Lunisolar.html#stem_and_branch/1"},{"type":"type","title":"Cldr.Calendar.Lunisolar.cycle/0","doc":"A sexigesimal cycle number","ref":"Cldr.Calendar.Lunisolar.html#t:cycle/0"},{"type":"type","title":"Cldr.Calendar.Lunisolar.lunar_month/0","doc":"A lunar month","ref":"Cldr.Calendar.Lunisolar.html#t:lunar_month/0"},{"type":"extras","title":"Lunisolar Calendars","doc":"# Lunisolar Calendars\n\nThis library implements the Chinese, Japanese and Korean lunisolar calendars. Lunisolar calendars use the lunar cycle to define months but the solar cycle to define years. In reconciling these two cycles, occasionally one of the lunar months is extended to bring the cycles into alignment. Since the number of months in a year does not change (they are always numbered 1 to 12), the extended month is called a \"leap month\".\n\nThe traditional Chinese, Japanese and Korean calendars all use the same astronomical principles with the only difference being the reference point from which the observations are made and the preferred epoch date. Today, the Chinese calendar uses Beijing as the reference, the Japanese calendar uses Tokyo and the Korean calendar uses Seoul.","ref":"readme.html"},{"type":"extras","title":"Usage - Lunisolar Calendars","doc":"[ex_cldr_calendars_lunisolar](https://hex.pm/packages/ex_cldr_calenars_lunisolar) conforms to both the `Calendar` and `Cldr.Calendar` behaviours and therefore the functions in the `Date`, `DateTime`, `NaiveDateTime`, `Time` and `Calendar` functions are supported.\n\nFor Elixir version 1.10 and later `Sigil_D` supports user-defined calendars:\n```elixir\niex> ~D[4660-03-30 Cldr.Calendar.Chinese]\n~D[4660-03-30 Cldr.Calendar.Chinese]\n```","ref":"readme.html#usage"},{"type":"extras","title":"Lunisolar Date representation - Lunisolar Calendars","doc":"Lunisolar calendars have a leap year when the lunar cycle falls too far out of alignment with the solar year. In those years, like Gregorian 2023, a leap month is inserted into the calendar. In 2023, the leap month is month 2 so the sequence of months goes \"month 1\" -> \"month 2\" -> \"leap month 2\" -> \"month 3\". The Elixir date structures can't accomodate this kind of annotation so the lunisolar calendar implementations in the library adopt a different approach. The month in the date struct is an *ordinal* month (ie considered the nth month) not the *cardinal* month as in other calendars. To create dates using the traditional lunisolar month notation see the next section.\n\nThis means that the month numbers in a lunisolar leap year are:\n\n| Calendar month | Date struct month | Example for Gregorian 2023 (Korean calendar 4356) using Date.to_string/2 in :ko locale |\n| :------------: | :---------------: | :------------------------------------------------------------------------------------- |\n| 1              | 1                 | \"4356. 1. 1.\"                                                                          |\n| 2              | 2                 | \"4356. 2. 1.\"                                                                          |\n| leap 2         | 3                 | \"4356. 윤2. 1.\"                                                                        |\n| 3              | 4                 | \"4356. 3. 1.\"                                                                          |\n| 4              | 5                 | \"4356. 4. 1.\"                                                                          |","ref":"readme.html#lunisolar-date-representation"},{"type":"extras","title":"Dates with lunar months - Lunisolar Calendars","doc":"Key events in China, Japan, Korea and other territories are defined by their lunar dates. Lunar new year is `01-01` (month-year), Buddha's birthday is celebrated on `04-08` and the Korean thanksgiving day is `08-15`. Note that these month numbers *do not* map directly to the date struct's ordinal month numbers. To facilitate creating dates in the traditional notation, the functions `Cldr.Calendar.Chinese.new/3`, `Cldr.Calendar.LunarJapanese.new/3` and `Cldr.Calendar.Korean.new/3` are provided. The notation `{lunar_month, :leap}` is used to denote the leap month in a leap year.\n\n```elixir\n# New Years day\niex> Cldr.Calendar.Chinese.new(4660, 1, 1)\n{:ok, ~D[4660-01-01 Cldr.Calendar.Chinese]}\n\n#Buddha's birthday\niex> Cldr.Calendar.LunarJapanese.new(1379, 4, 8)\n{:ok, ~D[1379-05-08 Cldr.Calendar.LunarJapanese]}\n\n# Korean thanksgiving day\niex> Cldr.Calendar.Korean.new(4356, 8, 15)\n{:ok, ~D[4356-09-15 Cldr.Calendar.Korean]}\n\n# A day in the leap month\niex> Cldr.Calendar.Chinese.new(4660, {3, :leap}, 1)\n{:ok, ~D[4660-04-01 Cldr.Calendar.Chinese]}\niex> Cldr.Calendar.Chinese.new(4660, {4, :leap}, 1)\n{:error, :invalid_date}\n```","ref":"readme.html#dates-with-lunar-months"},{"type":"extras","title":"Localization - Lunisolar Calendars","doc":"`ex_cldr_calendars_lunisolar` depends on [ex_cldr_calendars](https://hex.pm/packages/ex_cldr_calendars) which supports calendar localization. For full date and time formatting see [ex_cldr_dates_times](https://hex.pm/packages/ex_cldr_dates_times).\n\nBasic localization is executed by the `Cldr.Calendar.localize/3`. For example:\n\n```elixir\n# Months are ordinal numbers so in Gregorian 2023, Korean 4356\n# the ordinal month 3 is the Korean leap month 2\niex> Cldr.Calendar.localize(~D[4356-03-01 Cldr.Calendar.Korean], :month, locale: :ko)\n\"윤2월\"\n\n# Since there is a leap month prior to ordinal month 4\n# the month number localizes to 3\niex> Cldr.Calendar.localize(~D[4356-04-01 Cldr.Calendar.Korean], :month, locale: :ko)\n\"3월\"\n\niex> Cldr.Calendar.localize(~D[4660-04-01 Cldr.Calendar.Chinese], :day_of_week)\n\"Thu\"\n\niex> Cldr.Calendar.localize(~D[4660-04-01 Cldr.Calendar.Chinese], :day_of_week, locale: :zh)\n\"周四\"\n```","ref":"readme.html#localization"},{"type":"extras","title":"Relationship to other libraries - Lunisolar Calendars","doc":"This library is part of the [CLDR](https://cldr.unicode.org)-based libraries for Elixir including:\n\n* [ex_cldr](https://hex.pm/packages/ex_cldr)\n* [ex_cldr_numbers](https://hex.pm/packages/ex_cldr_numbers)\n* [ex_cldr_dates_times](https://hex.pm/packages/ex_cldr_dates_times)\n* [ex_cldr_units](https://hex.pm/packages/ex_cldr_units)\n* [ex_cldr_lists](https://hex.pm/packages/ex_cldr_lists)\n* [ex_cldr_messages](https://hex.pm/packages/ex_cldr_messages)\n* [ex_cldr_calendars](https://hex.pm/packages/ex_cldr_calendars)\n* [ex_cldr_currencies](https://hex.pm/packages/ex_cldr_currencies)","ref":"readme.html#relationship-to-other-libraries"},{"type":"extras","title":"Installation - Lunisolar Calendars","doc":"The package can be installed by adding `ex_cldr_calendars_lunisolar` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_cldr_calendars_lunisolar, \"~> 1.0\"}\n  ]\nend\n```\nDocumentation can be found at [https://hexdocs.pm/ex_cldr_calendars_lunisolar](https://hexdocs.pm/ex_cldr_calendars_lunisolar).","ref":"readme.html#installation"},{"type":"extras","title":"License","doc":"# License\n\nCopyright 2019 Kip Cole\n\nLicensed under the Apache License, Version 2.0 (the \"License\"); you may not use this file except in\ncompliance with the License. You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software distributed under the License\nis distributed on an \"AS IS\" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\nimplied. See the License for the specific language governing permissions and limitations under the\nLicense.","ref":"license.html"},{"type":"extras","title":"Changelog for Cldr_Calendars_Lunisolar v1.0.0","doc":"# Changelog for Cldr_Calendars_Lunisolar v1.0.0\n\nThis is the changelog for ex_cldr_calendars_lunisolar v1.0.0 released on April 28th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_calendars_lunisolar/tags)\n\n#","ref":"changelog.html"},{"type":"extras","title":"Enhancements - Changelog for Cldr_Calendars_Lunisolar v1.0.0","doc":"* Initial release supporting generalized lunisolar calendar development with implementations for the Chinese, Korean and Japanese lunisolar calendars.","ref":"changelog.html#enhancements"}],"content_type":"text/markdown"}